package fmon.builder

import java.io.File

import javafx.fxml.FXML
import javafx.fxml.FXMLLoader
import javafx.fxml.JavaFXBuilderFactory
import javafx.scene.{control => jfxsc, layout => jfxsl}

import scalafx.Includes._
import scalafx.stage.FileChooser
import FileChooser.ExtensionFilter

trait Savable {
  def saveTo(file: File): Unit
  def openFrom(file: File): Unit
}

class App {
  @FXML var pane: jfxsl.Pane = _
  
  var builder: Savable = _
  
  
  def open(): Unit = {
    val fileChooser = new FileChooser {
      title = "Open Resource File"
      extensionFilters ++= Seq(
        new ExtensionFilter("YAML Files", "*.yaml"),
        new ExtensionFilter("All Files", "*.*")
      )
    }
    
    val selectedFile = fileChooser.showOpenDialog(null)
    if (selectedFile != null) {
      builder openFrom selectedFile
    }
  }
  
  def saveAs(): Unit = {
    val fileChooser = new FileChooser {
      title = "Open Resource File"
      extensionFilters ++= Seq(
        new ExtensionFilter("YAML Files", "*.yaml"),
        new ExtensionFilter("All Files", "*.*")
      )
    }
    
    val selectedFile = fileChooser.showSaveDialog(null)
    if (selectedFile != null) {
      builder saveTo selectedFile
    }
  }
}